Index: examples/python_tests/balltime_rt2/README
===================================================================
--- examples/python_tests/balltime_rt2/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/balltime_rt2/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,4 +1,2 @@
-#!/bin/sh
-#
 #####################################################################
 # This example demonstrates using an oset (object set) to control access
@@ -15,5 +13,5 @@
 # [keyid:League].oset:players(string:'north'))
 # 
-# The example below lays out the policy that players of a given team can
+# The file, attr.py, lays out the policy that players of a given team can
 # go to the stadium when it is their team's gametime -- credential 1.
 # or any player of a team that is controlled by the League principal can
@@ -25,97 +23,33 @@
 # a player for team(south)
 #
-# The attached ./run_query file runs 3 queries.  First it confirms that John can 
+# The query.py file runs 3 queries.  First it confirms that John can 
 # go to stadium at his team's gametime, then it confirms that Mark cannot
 # go because it is not his gametime, but Mark can go to the stadium during
 # stadium's free-for-all early morning time
 
-# balltime_rt2_typed
+# balltime_rt2
 
-creddy --generate --cn League
-creddy --generate --cn John
-creddy --generate --cn Mark
-
-league_keyid=`creddy --keyid --cert League_ID.pem`
-john_keyid=`creddy --keyid --cert John_ID.pem`
-mark_keyid=`creddy --keyid --cert Mark_ID.pem`
-
-stadium_qFqT="stadium([string:'access'],[boolean:true],[time:?F[keyid:$league_keyid].oset:gametime([string:?T])])"
-stadium_qR="stadium([string:'access'],[boolean:?B:[true]],[time:?F:[20120228T080000..20120228T090000]])"
-
-players_qT="players([string:?T])" 
-
+# Credential 1
 #[keyid:league].role:stadium([string:'access'],[boolean:true],
 #          [time:?F:[keyid:league].oset.gametime([string:?T])])
 #                <-[keyid:league].role:players([string:?T])
-# Credential 1
-creddy --attribute \
-       --issuer League_ID.pem --key League_private.pem --role "$stadium_qFqT" \
-       --subject-cert League_ID.pem --subject-role "$players_qT" \
-       --out League_access_qFqT__League_players_qT_attr.der
 
+# Credential 2 
 #[keyid:league].role:stadium([string:'access'],[boolean:?B:[true],
 #              [time:?F:[20120228T080000..20120228T090000]])
 #               <- [keyid:league].role:players(string:?T) 
-# Credential 2 
-creddy --attribute \
-       --issuer League_ID.pem --key League_private.pem --role "$stadium_qR" \
-       --subject-cert League_ID.pem --subject-role "$players_qT" \
-       --out League_access_qR__League_players_qT_attr.der
 
-
+# Credential 3
 # [keyid:league].oset:gametime([time:20120228T130000])
 #                    <- [keyid:league].oset:players([string:'north') 
-# Credential 3
-creddy --attribute \
-        --issuer League_ID.pem --key League_private.pem \
-        --oset "gametime([string:'north'])" \
-        --subject-obj "[time:20120228T130000]" \
-        --out League_gametime_north__timeT_attr.der
 
+# Credential 4 
 # [keyid:league].oset:gametime([time:20120228T140000])
 #                    <- [keyid:league].oset:players([string:'south') 
-# Credential 4 
-creddy --attribute \
-        --issuer League_ID.pem --key League_private.pem \
-        --oset "gametime([string:'south'])" \
-        --subject-obj "[time:20120228T140000]" \
-        --out League_gametime_south__time2T_attr.der
 
+# Credential 5 
 # [keyid:league].role:players([string:'north'])<-[keyid:John]
-creddy --attribute \
-        --issuer League_ID.pem --key League_private.pem \
-        --role "players([string:'north'])" \
-        --subject-cert John_ID.pem \
-        --out League_players_north__John_attr.der
 
+# Credential 6 
 # [keyid:league].role:players([string:'south'])<-[keyid:Mark]
-creddy --attribute \
-        --issuer League_ID.pem --key League_private.pem \
-        --role "players([string:'south'])" \
-        --subject-cert Mark_ID.pem \
-        --out League_players_south__Mark_attr.der
 
-#####################################################################
-#league allows member of a team to access stadium at their team's designed time
-#
-#[keyid:league].role:stadium([string:'access'],[boolean:true],
-#          [time:?F:[keyid:league].oset.gametime([string:?T])])
-#                <-[keyid:league].role:players([string:?T])
-#
-#[keyid:league].role:stadium([string:'access'],[time:?Tm]) <- [principal:?P]
-#[keyid:league].oset:gametime(string:?Team) <- [time:?Tm]
-#[keyid:league].role:player(string:?Team) <- [principal:?P]
-#
-#
-#league.stadium(access,?Time:league.gametime(?Team)) <- league.players(?Teams)
-#              league.player(north) <- john
-#              league.player(south) <- mark 
-#              league.gametime(north) <- [time:'20120228T130000']
-#              league.gametime(south) <- [time:'20120228T140000']
-#
-#league.statdium(access,?FreeTime:[20120228T080000..20120228T090000]) 
-#                  <- league.players(_).
-#
-#[keyid:league].role:stadium([string:'access'],[boolean:?B:[true]],
-#              [time:?F:['20120228T080000'..'20120228T090000']])
-#               <- [keyid:league].role:players(string:?T) 
Index: examples/python_tests/balltime_rt2/attr.py
===================================================================
--- examples/python_tests/balltime_rt2/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/balltime_rt2/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,4 +2,7 @@
 
 """
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
+
 cmd1:env keystore=`pwd` ./attr.py 
 """
@@ -8,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -27,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 leagueID=ABAC.ID("League_ID.pem");
 leagueID.id_load_privkey_file("League_private.pem");
@@ -40,4 +46,5 @@
 
 ################################################
+# Credential 1, oset constraint on a time parameter
 #[keyid:league].role:stadium([string:'access'],[boolean:true],
 #          [time:?F:[keyid:league].oset.gametime([string:?T])])
@@ -46,8 +53,17 @@
 param2=ABAC.DataTerm("boolean","true")
 
+# setup the uninstantiated variable as the oset constraint's parameter
 param=ABAC.DataTerm("string","T")
+
+# make the oset condition
 condoset=ABAC.Oset(league,"gametime")
+
+# add the parameter for the constraint
 condoset.oset_add_data_term(param)
+
+# create the constraint with the oset condition
 cond=ABAC.Constraint(condoset)
+
+# make the data term that is being constrained
 param3=ABAC.DataTerm("time", "F", cond)
 head = ABAC.Role(league,"stadium")
@@ -55,11 +71,16 @@
 head.role_add_data_term(param2)
 head.role_add_data_term(param3)
-
 param=ABAC.DataTerm("string", "T")
 tail = ABAC.Role(league,"players")
 tail.role_add_data_term(param)
+
+# build up the attribute policy
 attr=ABAC.Attribute(head, 1800)
 attr.attribute_add_tail(tail)
+
+# finalize the policy
 attr.attribute_bake()
+
+# create the credential file for this policy
 attr.attribute_write_cert("League_access_qFqT__League_players_qT_attr.der")
 ctxt.load_attribute_file("League_access_qFqT__League_players_qT_attr.der")
@@ -69,12 +90,17 @@
 
 ################################################
-# ??? not sure if this is a valid policy
+# Credential 2, 2 different range constraints, one on a boolean and
+#               and the other is on a time
 #[keyid:league].role:stadium([string:'access'],[boolean:?B:[true],
 #              [time:?F:[20120228T080000..20120228T090000]])
 #               <- [keyid:league].role:players(string:?T)
 param1=ABAC.DataTerm("string","'access'")
+
+# generate a range constraint with a single target value
 cond=ABAC.Constraint("boolean")
 cond.constraint_add_boolean_target("true")
 param2=ABAC.DataTerm("boolean", "B", cond)
+
+# generate a range constraint with a min and a max 
 cond=ABAC.Constraint("time")
 cond.constraint_add_time_min("20120228T080000")
@@ -100,4 +126,5 @@
 
 #################################################
+# Credential 3
 # [keyid:league].oset:gametime([string:'north'])
 #                    <- [time:20120228T130000]
@@ -117,4 +144,5 @@
 
 #################################################
+# Credential 4
 # [keyid:league].oset:gametime([string:'south']) 
 #                    <-[time:20120228T140000]
@@ -134,4 +162,5 @@
 
 #################################################
+# Credential 5
 # [keyid:league].role:players([string:'north'])<-[keyid:John]
 param=ABAC.DataTerm("string", "'north'")
@@ -149,4 +178,5 @@
 
 #################################################
+# Credential 6
 # [keyid:league].role:players([string:'south'])<-[keyid:Mark]
 param=ABAC.DataTerm("string", "'south'")
@@ -164,4 +194,2 @@
 
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/balltime_rt2/query.py
===================================================================
--- examples/python_tests/balltime_rt2/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/balltime_rt2/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 leagueID=ABAC.ID("League_ID.pem");
 leagueID.id_load_privkey_file("League_private.pem");
@@ -33,4 +37,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# can john go to stadium at 1pm?
 # role=[keyid:league].role:stadium([string:'access'],[boolean:true],[time:20120228T130000]) 
 # p=[keyid:john]
@@ -49,4 +66,5 @@
 
 ##########################################################################
+# can mark go to stadium at 11am?
 # role=[keyid:league].role:stadium([string:'access'],[boolean:true],[time:20120228T110000]) 
 # p=[keyid:mark]
@@ -65,4 +83,5 @@
 
 ##########################################################################
+# can mark go to stadium at 8am then?
 # role=[keyid:league].role:stadium([string:'access'],[boolean:true],[time:20120228T080000])
 # p=[keyid:mark]
@@ -79,22 +98,2 @@
 for c in out[1]:
     print "%s <- %s" % (c.head_string(), c.tail_string())
-
-##########################################################################
-# dump the yap dB
-#
-#ctxt.dump_yap_db()
-
-##########################################################################
-# dump the loaded principals/policies
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
Index: examples/python_tests/balltime_rt2/run_test
===================================================================
--- examples/python_tests/balltime_rt2/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/balltime_rt2/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 echo '---setup principals'
Index: examples/python_tests/balltime_rt2/setup.py
===================================================================
--- examples/python_tests/balltime_rt2/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/balltime_rt2/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,4 +2,6 @@
 
 """
+See README for the semantics.  This creates principals
+used by the example.
 """
 import os
Index: examples/python_tests/basic_id/README
===================================================================
--- examples/python_tests/basic_id/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/basic_id/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,9 +1,32 @@
-#!/bin/sh
+#####################################################################
+# This example demonstrates various ways to create and access
+# ID credentials using libabac api
+#  
 
-#####################################################################
-# This example demonstrates various ways to access and create 
-# ID credentials using libabac api using python
-# In yap db, the ID credential is stored as: isType(pIDname,keyid)
+case 1: make ID 
+        writing cert file
+        writing key file
+        load cert, key file
 
+case 2: make ID
+        load ID
 
-#  
+case 3: make ID
+        write key combo file
+        write cert combo file
+        load combo file
+
+case 4: make ID
+        write key unconventional name
+        write cert unconventional name
+        load unconventional filename
+        
+case 5: make ID
+        write cert to combo file
+        load combo file
+
+case 6: make ID
+        write key to combo file
+        load combo file
+
+case 7: load unknown combo file
Index: examples/python_tests/basic_id/id.py
===================================================================
--- examples/python_tests/basic_id/id.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/basic_id/id.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -16,7 +16,13 @@
 print "ABAC version %s" % ctxt.version()
 
-keystore=os.environ["keystore"]
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1) 
 
-ctxt.load_directory(keystore)
 out = ctxt.context_principals()
 print "...initial principal set..."
@@ -25,36 +31,56 @@
 print "\n" 
 
+## creating and writing out using libabac ID
 id=ABAC.ID("Mary", 0)
 print "adding -> %s(good)" % id.id_name()
 id.id_write_cert("Mary_ID.pem")
 id.id_write_privkey("Mary_private.pem")
+## load principal with id/key file pair
+## note, with this, we do not have handle on the keyid
+## to Mary but it will be in the db
 ctxt.load_id_files("Mary_ID.pem","Mary_private.pem")
 
+## creating principal using ID
 nid=ABAC.ID("Jack", 0)
 print "adding -> %s(good)" % nid.id_name()
+## load principal directly with the ID, no external
+## credential files were created
 ctxt.load_id(nid)
 
+## creating principal using ID
 id=ABAC.ID("Mark", 0)
 print "adding -> %s(good)" % id.id_name()
+## write cert and key content to a combo file. One is appended
+## after another
 id.id_write_privkey("Mark_IDKEY.pem")
 id.id_write_cert("Mark_IDKEY.pem")
+## load principal in with the combo file with the tandem format
 ctxt.load_id_file("Mark_IDKEY.pem")
 
+## creating principal using ID
 id=ABAC.ID("John", 0)
 print "adding -> %s(good,invisible)" % id.id_name()
 id.id_write_privkey("John_other.pem")
 id.id_write_cert("John_other.pem")
+## load id without the key file
 ctxt.load_id_file("John_other.pem")
 
+## creating principal using ID
 id=ABAC.ID("Lori", 0)
 print "adding -> %s(good,nokey)" % id.id_name()
+## write just cert into the combo file
 id.id_write_cert("Lori_IDKEY.pem")
+##load principal from a combo file that only contains cert part
 ctxt.load_id_file("Lori_IDKEY.pem")
 
+## creating principal using ID
 id=ABAC.ID("Tom", 0)
 print "adding -> %s(bad,nocert)" % id.id_name()
+## write just key into the combo file
 id.id_write_privkey("Tom_IDKEY.pem")
+## load principal from combo file that only contains key part
 ctxt.load_id_file("Tom_IDKEY.pem")
 
+## failure case, loading a non-existing combo file
 print "adding -> Casper(bad,unknown file)"
 ctxt.load_id_file("Casper_IDKEY.pem")
Index: examples/python_tests/basic_id/run_test
===================================================================
--- examples/python_tests/basic_id/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/basic_id/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,6 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
 
 g_cmd_sha=`grep "cmd1:" id.py |sed "s/cmd1://g" `
Index: examples/python_tests/basic_id/setup.py
===================================================================
--- examples/python_tests/basic_id/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/basic_id/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,6 @@
 
 """
-  to test with python
-
-
+See README for the semantics.  This creates principals
+using ID and write out the credential file pair, cert/privkey
 """
 import os
Index: examples/python_tests/evaluator_rt1/README
===================================================================
--- examples/python_tests/evaluator_rt1/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/evaluator_rt1/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,3 +1,2 @@
-#!/bin/sh
 #
 # This example demonstrates linking parameterized roles and delegating across
@@ -12,65 +11,28 @@
 # credentials 5 and 6 idicate that John and Maryann are ISI employees.
 # 
-# the attached ./run_query script queries that USC grants John the role of evaluator
+# The query.py script queries that USC grants John the role of evaluator
 # of Maryann, that ISI asserts John is Maryann's manager and that John is an
 # ISI employee.
 
-# evaluator_rt1_typed
+# evaluator_rt1
 
-#[keyid:USC].role:employee <-?- [keyid:John]
-#[keyid:USC].role:evaluatorOf([keyid:Maryann])<-?- [keyid:John]
+# Credential 1
+#[keyid:USC].role:evaluatorOf([principal:?K])
+#                                  <-[keyid:USC].role:managerOf([principal:?K])
 
-creddy --generate --cn ISI
-creddy --generate --cn USC
-creddy --generate --cn Maryann
-creddy --generate --cn John
+# Credential 2
+#[keyid:USC].role:managerOf([principal:?K])
+#                                  <-[keyid:ISI].role:managerOf([principal:?K])
 
-isi_keyid=`creddy --keyid --cert ISI_ID.pem`
-usc_keyid=`creddy --keyid --cert USC_ID.pem`
-maryann_keyid=`creddy --keyid --cert Maryann_ID.pem`
-john_keyid=`creddy --keyid --cert John_ID.pem`
+# Credential 3
+#[keyid:ISI].role:managerOf([keyid:Maryann]) <- [keyid:John]
 
-managerof_maryann="managerOf([keyid:$maryann_keyid])"
+# Credential 4
+#[keyid:USC].role:employee <- [keyid:ISI].role:employee
 
-#[keyid:USC].role:evaluatorOf([principal:?K])<-[keyid:USC].role:managerOf([principal:?K])
-# Credential 1
-creddy --attribute \
-       --issuer USC_ID.pem --key USC_private.pem --role 'evaluatorOf([principal:?K])' \
-       --subject-cert USC_ID.pem --subject-role 'managerOf([principal:?K])' \
-       --out USC_evaluatorof_qK__USC_managerof_qK_attr.der
+# Credential 5
+#[keyid:ISI].role:employee  <- [keyid:Maryann]
 
-#[keyid:USC].role:managerOf([principal:?K])<-[keyid:ISI].role:managerOf([principal:?K])
-# Credential 2
-creddy --attribute \
-       --issuer USC_ID.pem --key USC_private.pem --role 'managerOf([principal:?K])' \
-       --subject-cert ISI_ID.pem --subject-role 'managerOf([principal:?K])' \
-       --out USC_managerof_qK__USC_employee_attr.der
+# Credential 6
+#[keyid:ISI].role:employee <- [keyid:John]
 
-#[keyid:ISI].role:managerOf([keyid:Maryann]) <- [keyid:John]
-# Credential 3
-creddy --attribute \
-       --issuer ISI_ID.pem --key ISI_private.pem --role "$managerof_maryann" \
-       --subject-cert John_ID.pem \
-       --out ISI_manageof_Maryann__John_attr.der
-
-#[keyid:USC].role:employee <- [keyid:ISI].role:employee
-# Credential 4
-creddy --attribute \
-       --issuer USC_ID.pem --key USC_private.pem --role employee \
-       --subject-cert ISI_ID.pem --subject-role employee \
-       --out USC_employee__ISI_employee_attr.der
-
-#[keyid:ISI].role:employee  <- [keyid:Maryann]
-# Credential 5
-creddy --attribute \
-       --issuer ISI_ID.pem --key ISI_private.pem --role employee \
-       --subject-cert Maryann_ID.pem \
-       --out ISI_employee__Maryann_attr.der
-
-#[keyid:ISI].role:employee <- [keyid:John]
-# Credential 6
-creddy --attribute \
-       --issuer ISI_ID.pem --key ISI_private.pem --role employee \
-       --subject-cert John_ID.pem \
-       --out ISI_employee__John_attr.der
-
Index: examples/python_tests/evaluator_rt1/attr.py
===================================================================
--- examples/python_tests/evaluator_rt1/attr.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/evaluator_rt1/attr.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,6 @@
 
 """
-  to test with python
+See README in this directory for the semantics of the example.  This file
+constructs the credentials described and puts copies into this directory
 
 cmd1:env keystore=`pwd` ./attr.py 
@@ -10,10 +11,12 @@
 import ABAC
 
-keystore=os.environ["keystore"]
-
 ctxt = ABAC.Context()
 print "ABAC version %s" % ctxt.version()
 
-ctxt.load_directory(keystore)
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
 
 out = ctxt.context_principals()
@@ -29,4 +32,5 @@
 print "\n"
 
+# retrieve principals' keyid value from local credential files
 isiID=ABAC.ID("ISI_ID.pem")
 isiID.id_load_privkey_file("ISI_private.pem");
@@ -64,4 +68,5 @@
 
 #################################################
+# Credential 1, double uninstantiated parameters
 # [keyid:USC].role:managerOf([principal:?K])
 #            <-[keyid:ISI].role:managerOf([principal:?K])
@@ -70,10 +75,18 @@
 head = ABAC.Role(usc,"managerOf")
 head.role_add_data_term(param)
+
+# create variable princpal parameter
 param=ABAC.DataTerm("principal", "K")
 tail = ABAC.Role(isi,"managerOf")
 tail.role_add_data_term(param)
 attr=ABAC.Attribute(head, 1800)
+
+# compose the attribute for the policy
 attr.attribute_add_tail(tail)
+
+# finalize the policy
 attr.attribute_bake()
+
+# write the policy to a file
 attr.attribute_write_cert("USC_managerof_qK__USC_employee_attr.der")
 ctxt.load_attribute_file("USC_managerof_qK__USC_employee_attr.der")
@@ -83,4 +96,5 @@
 
 #################################################
+# Credential 2
 # [keyid:ISI].role:managerOf([keyid:Maryann]) 
 #                        <- [keyid:John]
@@ -99,4 +113,5 @@
 
 ################################################
+# Credential 3
 # [keyid:USC].role:employee <- [keyid:ISI].role:employee
 head=ABAC.Role(usc,"employee")
@@ -106,12 +121,12 @@
 attr.attribute_bake()
 attr.attribute_write_cert("USC_employee__ISI_employee_attr.der")
-#ctxt.load_attribute_file("USC_employee__ISI_employee_attr.der")
 ctxt.load_attribute(attr)
-#print attr.string() 
-#print attr.typed_string()
-#print "\n"
+print attr.string() 
+print attr.typed_string()
+print "\n"
 
 
 #################################################
+# Credential 4
 # [keyid:ISI].role:employee  <- [keyid:Maryann]
 head = ABAC.Role(isi,"employee")
@@ -121,5 +136,4 @@
 attr.attribute_bake()
 attr.attribute_write_cert("ISI_employee__Maryann_attr.der")
-#ctxt.load_attribute_file("ISI_employee__Maryann_attr.der")
 ctxt.load_attribute(attr)
 print attr.string() 
@@ -128,4 +142,5 @@
 
 #################################################
+# Credential 4
 # [keyid:ISI].role:employee  <- [keyid:John]
 head = ABAC.Role(isi,"employee")
@@ -135,5 +150,4 @@
 attr.attribute_bake()
 attr.attribute_write_cert("ISI_employee__John_attr.der")
-#ctxt.load_attribute_file("ISI_employee__John_attr.der")
 ctxt.load_attribute(attr)
 print attr.string() 
@@ -141,4 +155,2 @@
 print "\n"
 
-ctxt.dump_yap_db()
-##
Index: examples/python_tests/evaluator_rt1/query.py
===================================================================
--- examples/python_tests/evaluator_rt1/query.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/evaluator_rt1/query.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,5 +2,5 @@
 
 """
-  to test with python
+Run the queries described in README
 
 cmd1:env keystore=`pwd` ./query.py 
@@ -14,10 +14,14 @@
 ctxt = ABAC.Context()
 
-# print "ABAC version %s" % ctxt.version()
+# Keystore is the directory containing the principal credentials.
+# Load existing principals and/or policy credentials
+if (os.environ.has_key("keystore")) :
+    keystore=os.environ["keystore"]
+    ctxt.load_directory(keystore)
+else:
+    print("keystore is not set...")
+    exit(1)
 
-keystore=os.environ["keystore"]
-
-ctxt.load_directory(keystore)
-
+# retrieve principals' keyid value from local credential files
 isiID=ABAC.ID("ISI_ID.pem")
 isiID.id_load_privkey_file("ISI_private.pem");
@@ -37,4 +41,17 @@
 
 ##########################################################################
+# dump the loaded principals/policies
+#
+out = ctxt.context_principals()
+print "\n...final principal set..."
+for x in out[1]:
+    print "%s " % x.string()
+out = ctxt.context_credentials()
+print "\n...final policy attribute set..."
+for c in out[1]:
+    print "%s <- %s" % (c.head_string(), c.tail_string())
+
+##########################################################################
+# is john an evaluator of maryann ?
 #role=[keyid:USC].role:evaluatorOf([keyid:Maryann])
 #p=[keyid:John]
@@ -49,4 +66,5 @@
 
 ##########################################################################
+# is john a manager of maryann ?
 #role=[keyid:USC].role:managerOf([keyid:Maryann])
 #p=[keyid:John]
@@ -61,4 +79,5 @@
 
 ##########################################################################
+# is john an employee of usc ?
 # role=[keyid:USC].role:employee 
 # p=[keyid:John]"
@@ -69,18 +88,2 @@
 for c in out[1]:
     print "%s <- %s" % (c.head_string(), c.tail_string())
-
-
-##########################################################################
-# dump the loaded principals/policies 
-#
-out = ctxt.context_principals()
-print "\n...final principal set..."
-for x in out[1]:
-    print "%s " % x.string()
-print "\n"
-out = ctxt.context_credentials()
-print "\n...final policy attribute set..."
-for c in out[1]:
-    print "%s <- %s" % (c.head_string(), c.tail_string())
-print "\n"
-
Index: examples/python_tests/evaluator_rt1/run_test
===================================================================
--- examples/python_tests/evaluator_rt1/run_test	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/evaluator_rt1/run_test	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,7 +1,3 @@
 #!/bin/sh 
-
-ABAC_PROVER_PATH="/home/mei/Deter/abac/libabac"
-export ABAC_PROVER_PATH
-
 
 echo '---setup principals'
Index: examples/python_tests/evaluator_rt1/setup.py
===================================================================
--- examples/python_tests/evaluator_rt1/setup.py	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/evaluator_rt1/setup.py	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -2,7 +2,6 @@
 
 """
-  to test with python
-
-
+See README for the semantics.  This creates principals
+used by the example.
 """
 import os
Index: examples/python_tests/experiment_create_rt0/README
===================================================================
--- examples/python_tests/experiment_create_rt0/README	(revision 47d5cf98015ecd9eee00b2d9a4dd2f7e57f042ea)
+++ examples/python_tests/experiment_create_rt0/README	(revision f824a9ec465246e1555b44ec89522ae2ad35c47e)
@@ -1,4 +1,2 @@
-#!/bin/sh
-#
 #
 #Acme runs a testbed. They've delegated the authority to create
@@ -18,47 +16,28 @@
 #    Alice.power_user <- Bob
 #
-#From these credentials, it is possible to construct a proof graph
-#showing that Acme.experiment_create <- Bob.
+#From these credentials, it is possible to show that 
+#    Acme.experiment_create <- Bob.
 #
-#Note that there is a one-to-one correspondence with each credential
-#above and the attribute certificates below.
+#In query.py, it checks if Alice is a admin of Globotron which is true;
+#and if Bob is an admin of Globotron which is not true; and also show
+# that Bob can create experiment at Acme
 #
+# experiment_create_rt0 
 
-# experiment_create_rt0_typed 
+# Credential 1
+#[keyid:Acme].role:experiment_create 
+#                 <- [keyid:Acme].role:partner.role:experiment_create
 
-creddy --generate --cn Acme
-creddy --generate --cn Globotron
-creddy --generate --cn Alice
-creddy --generate --cn Bob
+# Credential 2
+#[keyid:Acme].role:partner <- [keyid:Globotron]
 
-#[keyid:Acme].role:experiment_create <- [keyid:Acme].role:partner.role:experiment_create
-creddy --attribute \
-       --issuer Acme_ID.pem --key Acme_private.pem --role experiment_create \
-       --subject-cert Acme_ID.pem --subject-role partner.experiment_create \
-       --out Acme_experiment_create__Acme_partner_experiment_create_attr.der
+# Credential 3
+#[keyid:Globotron].role:expriment_create 
+                 <- [keyid:Globotron].role:admin.role:power_user
 
-#[keyid:Acme].role:partner <- [keyid:Globotron]
-creddy --attribute \
-       --issuer Acme_ID.pem --key Acme_private.pem --role partner \
-       --subject-cert Globotron_ID.pem \
-       --out Acme_partner__Globotron_attr.der 
+# Credential 4
+#[keyid:Globotron].role:admin <- [keyid:Alice]
 
-#[keyid:Globotron].role:expriment_create <- [keyid:Globotron].role:admin.role:power_user
-creddy --attribute \
-       --issuer Globotron_ID.pem --key Globotron_private.pem --role experiment_create \
-       --subject-cert Globotron_ID.pem --subject-role admin.power_user \
-       --out Globotron_experiment_create__Globotron_admin_power_user_attr.der
+# Credential 5
+#[keyid:Alice].role:power_user <- [keyid:Bob]
 
-#[keyid:Globotron].role:admin <- [keyid:Alice]
-creddy --attribute \
-       --issuer Globotron_ID.pem --key Globotron_private.pem --role admin \
-       --subject-cert Alice_ID.pem \
-       --out Globotron_admin__Alice_attr.der
-
-#[keyid:Alice].role:power_user <- [keyid:Bob]
-creddy --attribute \
-       --issuer Alice_ID.pem --key Alice_private.pem --role power_user \
-       --subject-cert Bob_ID.pem \
-       --out Alice_power_user__Bob_attr.der
-
-
